#include <iostream>

using namespace std;

class Dispenser{
	public:
		Dispenser(): next(0){
		};
		
		void add(Dispenser *n) {
			if (next) 
				next->add(n); 
			else 
				next = n;
		};
		
		virtual void dispense(int i)
		{
			if(i > 0)
			{
				if(next)
					next->dispense(i);
				else
					cout << "R" << i << " can not be dispensed" << endl;
			}
			else
				cout << "Required amount was dispensed" << endl;

		}; 
	private:
		Dispenser* next;
};


class ConcreteDispenser: public Dispenser {
public:
	ConcreteDispenser(int v):
		Dispenser(), value(v){};
	
	void dispense(int i)
	{
		while(i >= value)
		{
			cout << "R" << value << " dispenser dispenses R" << value << endl;
			i -= value;
		}

		cout << "R" << i << " to small for R"  << value << " dispenser - pass  on" << endl;
		Dispenser :: dispense(i);
	}
private:
	int value;
};

int main() 
{
	//Assemble the chain:
	Dispenser* machine = new ConcreteDispenser(200);
	machine->add(new ConcreteDispenser(100));
	machine->add(new ConcreteDispenser(50));
	machine->add(new ConcreteDispenser(20));
	machine->add(new ConcreteDispenser(10));

	int n;
	cout << "Amount to be dispensed: R";
  	cin >> n;
  	machine->dispense(n);
  	cout << endl;
 
	return 0;
}
